/* TEMPLATE.CPP
   Przykadowa wtyczka dla programu Konnekt...
   Idealny sposb eby zacz pisa co swojego ...

   Powinna zosta skompilowana jako Win32DLL z wykorzystaniem
   wielowtkowej wersji biblioteki CRT!

   (c)2002 hao | Stamina
   http://www.stamina.eu.org/konnekt/sdk/
*/ 
#define _WIN32_WINNT 0x0600
#define _WIN32_WINDOWS 0x600
#include "windows.h"
#include "konnekt/plug_export.h"
#include "konnekt/ui.h"
#include "konnekt/plug_func.h"
int cnt_info_prevOwner;
int __stdcall DllMain(void * hinstDLL, unsigned long fdwReason, void * lpvReserved)
{
        return true;
}
//---------------------------------------------------------------------------
/* Wszystkie ponisze funkcje nie s wymagane (z wyjtekim IMEssageProc)...
   ale z nimi wszystko wyglda czytelniej :)
*/
int Init() {
  /* Tutaj inicjalizujemy wtyczk,
       zgaszamy dania pocze itp. */
  return 1;
}

int DeInit() {
  /* Najlepsze miejsce eby posprzta...
  */
  return 1;
}

int IStart() {
  /* Tutaj wtyczk uruchamiamy */
     // tworzymy obiekt z parametrami akcji "Wicej" 
		sUIActionInfo nfo(IMIG_CNT , IMIA_CNT_IGNORE);
        nfo.mask = UIAIM_ALL; // chcemy pobra wszystko...
        nfo.txt = new char [100];
        nfo.txtSize = 99;
        UIActionGet(nfo); // pobieramy wszystkie dane
        // Zapisujemy w zmiennej globalnej (typu int) poprzedniego waciciela
        cnt_info_prevOwner = ICMessage(IMI_ACTION_GETOWNER , (int)&nfo.act);
        // Jak dostaniemy bdny wynik (np. gdy jest stare UI) uznajemy e wacicielem jest interfejs
        if (cnt_info_prevOwner == 0) {cnt_info_prevOwner = ICMessage(IMC_PLUG_ID , 0);}
        // Niszczymy star akcj
        ICMessage(IMI_ACTION_REMOVE , (int)&nfo.act);
        // I reinkarnujemy (powstanie w tym samym miejscu, z tymi samymi parametrami! Nic nie trzeba ustawia, chyba e co sami dodajemy...)
        ICMessage(IMI_ACTION , (int)&nfo);
        delete [] nfo.txt;
        // i ju... voilla

  return 1;
}
int IEnd() {
  /* Tutaj wtyczk wyczamy */
  return 1;
}

int ISetCols() {
  /* Tutaj rejestrujemy kolumny w plikach ustawie.
     Pamitaj o tym e identyfikatory MUSZ by UNIKATOWE! */
  return 1;
}

int IPrepare() {
  /* Tutaj rejestrujemy sie w interfejsie */
  return 1;
}

ActionProc(sUIActionNotify_base * anBase) {

  switch (anBase->act.id) {
	case IMIA_CNT_IGNORE:
		{
		  if (anBase->code == ACTN_ACTION) {
             if (!ICMessage(IMI_CONFIRM , (int)"Czy na pewno chcesz zignorowa ten kontakt?")) 
                           return 0; // nie przekazujemy zdarzenia do UI - UI go nie dostanie - okno si nie otworzy.. to tak proste!
	            }
                        // przekazujemy do poprzedniego waciciela...
            return IMessageDirect(IM_UIACTION , cnt_info_prevOwner , (int)anBase);

		break;
		}
  }
  return 0;
}



int __stdcall IMessageProc(sIMessage_base * msgBase) {
    /* Tam gdzie nie uywasz parametrw, najbezpieczniej korzysta z msgBase */
    /* Ponisza linijka jest dla Twojej wygody... 
     Wikszo (o ile nie wszystkie) wiadomoci przesyana jest jako sIMessage_2params,
     korzystamy wtedy z obiektu msg, w przeciwnym razie z msgBase, lub castujemy do spodziewanego typu.
    */
    sIMessage_2params * msg = (msgBase->s_size>=sizeof(sIMessage_2params))?static_cast<sIMessage_2params*>(msgBase):0;
    switch (msgBase->id) {
    /* Wiadomoci na ktre TRZEBA odpowiedzie */
	case IM_PLUG_NET:        return NET_OTHER; // Zwracamy warto NET, ktra MUSI by rna od 0!
    case IM_PLUG_TYPE:       return IMT_UI; // Zwracamy jakiego typu jest nasza wtyczka (ktre wiadomoci bdziemy obsugiwa)
    case IM_PLUG_VERSION:    return (int)"1.0.0.0"; // Wersja wtyczki tekstowo major.minor.release.build ..., lub 0 jeeli wersja zapisana jest w zasobach DLLa
    case IM_PLUG_SDKVERSION: return KONNEKT_SDK_V;  // Ta linijka jest wymagana!
    case IM_PLUG_SIG:        return (int)"IGNORE"; // Sygnaturka wtyczki (krtka, kilkuliterowa nazwa)
    case IM_PLUG_NAME:       return (int)"AskIgnore"; // Pena nazwa wtyczki (ale najlepiej nie za duga!)
    case IM_PLUG_NETNAME:    return 0; // Nazwa obsugiwanej sieci (o ile jak sie obsuguje)
    case IM_PLUG_INIT:       Plug_Init(msg->p1,msg->p2);return Init();
    case IM_PLUG_DEINIT:     Plug_Deinit(msg->p1,msg->p2);return DeInit();

    case IM_SETCOLS:     return ISetCols();

    case IM_UI_PREPARE:      return IPrepare();
    case IM_START:           return IStart();
    case IM_END:             return IEnd();

    case IM_UIACTION:        return ActionProc((sUIActionNotify_base*)msg->p1);

    /* Tutaj obsugujemy wszystkie pozostae komunikaty */
	/* Z kadego komunikatu trzeba zwraca warto. W przeciwnym razie, 
	   zostanie ustawiony bd i komunikat zostanie uznany za nie obsuony */

 }
 if (Ctrl) Ctrl->setError(IMERROR_NORESULT);
 return 0;
}

